#include <systemctrl.h>
#include <pspctrl.h>
#include <pspsyscon.h>
#include <string.h>

PSP_MODULE_INFO("REBOOT", 0x1000, 1, 0);
PSP_MAIN_THREAD_ATTR(0);

#define MAX_THREAD 64

void CheckCleanExit(void){
	SceUID thids[MAX_THREAD];
	int thid_count = 0;
	int i;
	SceKernelThreadInfo thinfo;
	//if sceKernelExitGame was called, exit before the system crashes
	sceKernelGetThreadmanIdList(SCE_KERNEL_TMID_Thread, thids, MAX_THREAD, &thid_count);
	for(i=0; i < thid_count; i++){
		memset(&thinfo, 0, sizeof(SceKernelThreadInfo));
		thinfo.size = sizeof(SceKernelThreadInfo);
		sceKernelReferThreadStatus(thids[i], &thinfo);
		if(strcmp(&thinfo.name[0], "SceKernelLoadExecThread") == 0){
			sceKernelSelfStopUnloadModule(0, 0, NULL);
		}
	}
}

int reboot(SceSize args, void *argp){
	unsigned int paddata_old = 0;
	SceCtrlData paddata_now;
	while(1){
		CheckCleanExit();
		sceCtrlPeekBufferPositive(&paddata_now, 1);
		if(paddata_now.Buttons != paddata_old){
			if((paddata_now.Buttons & (PSP_CTRL_HOME | PSP_CTRL_SELECT)) == (PSP_CTRL_HOME | PSP_CTRL_SELECT)){
				sceSysconPowerStandby();
			}
			if((paddata_now.Buttons & (PSP_CTRL_HOME | PSP_CTRL_START)) == (PSP_CTRL_HOME | PSP_CTRL_START)){
				sceSysconResetDevice(1, 1);
			}
		}
		paddata_old = paddata_now.Buttons;
		sceKernelDelayThread(100000);
	}
	return 0;
}

int module_start(SceSize args, void *argp){
	sceCtrlSetSamplingCycle(0);
	sceCtrlSetSamplingMode(0);
	sceKernelStartThread(sceKernelCreateThread("reboot_thread", reboot, 0x18, 0x1000, 0, NULL), 0, 0);
	return 0;
}
